local function f(x)
	return x^6-6*x^5+15*x^4-20*x^3+15*x^2-6*x+1
	--return x*(x*(x*(x*(x*(x-6)+15)-20)+15)-6)+1
	--return (x-1)^6

end

local function curve(t,sx,sy)
	local x=t
	local y=f(x)
	return (x-1)/sx,y/sy
end

local function coords(xmin,xmax,ymin,ymax)
	local W,H=love.graphics.getDimensions()
	love.graphics.translate(0,H)
	love.graphics.scale(1,-1)
	local dx=xmax-xmin
	local dy=ymax-ymin
	local s=math.min(W/dx,H/dy)
	love.graphics.translate((W-s*dx)/2,(H-s*dy)/2)
	love.graphics.scale(s,s)
	love.graphics.translate(-xmin,-ymin)
	love.graphics.setLineWidth(0)
end

local function graph(sx,n)
	local xmin=1-sx
	local xmax=1+sx
	local dx=(xmax-xmin)/n
	local sy=0
	for x=xmin,xmax,dx do
		local y=f(x)
		sy=math.max(sy,math.abs(y))
	end
	--sy=sy/10
	--sy=20e-15
	love.graphics.print(string.format("sx=%.0e sy=%.0e n=%d",sx,sy,n))
	coords(-1.1,1.1,-1.1,1.1)
	--love.graphics.setColor(255,0,0)
	--love.graphics.line(-1,0,1,0)
	love.graphics.setColor(100,100,100)
	local x0,y0=curve(xmin,sx,sy)
	for x=xmin,xmax,dx do
		local x1,y1=curve(x,sx,sy)
		love.graphics.line(x0,y0,x1,y1)
		x0,y0=x1,y1
	end
	local x1,y1=curve(xmax,sx,sy)
	love.graphics.line(x0,y0,x1,y1)
	love.graphics.setColor(255,0,0)
	love.graphics.points(0,0)
end

function love.load()
	love.window.setMode(640,640,{resizable=true})
	love.window.setPosition(0,0)
	love.window.setTitle("curve sampling")
	love.graphics.setBackgroundColor(0,0,0)
	love.graphics.setBackgroundColor(255,255,255)
	love.graphics.clear()
	love.graphics.setFont(love.graphics.newFont(24))
	love.graphics.setPointSize(9)
end

local sx=1
local N=32

local sx=0.005
local N=100

local sx=0.15
local N=100

local sx=1
local N=100

function love.keypressed(key)
	if key == 'q' or key == 'escape' then
		love.event.quit()
	elseif key == '[' then
		sx=sx/2
	elseif key == ']' then
		sx=sx*2
	elseif key == ',' then
		N=N*2
	elseif key == '.' then
		N=N/2
	end
end

function love.draw()
	graph(sx,N)
end
