local function coords(xmin,xmax,ymin,ymax)
	local W,H=love.graphics.getDimensions()
	love.graphics.translate(0,H)
	love.graphics.scale(1,-1)
	local dx=xmax-xmin
	local dy=ymax-ymin
	local s=math.min(W/dx,H/dy)
	love.graphics.translate((W-s*dx)/2,(H-s*dy)/2)
	love.graphics.scale(s,s)
	love.graphics.translate(-xmin,-ymin)
	love.graphics.setLineWidth(0)
end

local function interval(a,b,y,A,B,Y)
	local s=10
	y=1-y/s
	Y=1-Y/s
	local c=(a+b)/2
	local C=(A+B)/2
	love.graphics.setColor(100,100,100)
	love.graphics.setLineWidth(0.005)
	love.graphics.line(a,y,b,y)
	love.graphics.setLineWidth(0)
	love.graphics.setColor(200,200,200)
	love.graphics.line(c,y,C,Y)
	love.graphics.setColor(255,0,0)
	love.graphics.points(a,y)
	love.graphics.setColor(0,0,255)
	love.graphics.points(b,y)
	love.graphics.setColor(255,0,255)
	love.graphics.points(c,y)
	love.graphics.points(C,Y)
end

local function plot(xmin,xmax,ymin,ymax,n)
	coords(xmin,xmax,ymin,ymax)
	love.graphics.setPointSize(20)
	local a,b,c=1,2,1.5
	interval(a,b,0,a,b,0)
	for i=1,n do
		local A,B=a,b
		c=(a+b)/2
		if c^2>2 then
			b=c
		else
			a=c
		end
		interval(a,b,i,A,B,i-1)
	end
	c=(a+b)/2
	love.graphics.origin()
	love.graphics.setColor(100,100,100)
	love.graphics.print(string.format("%d\t%f\t%f\t%f",n,c,c^2,b-a),10,10)
end

function love.load()
	--love.window.setFullscreen(true)
	love.window.setMode(800,800,{resizable=true})
	love.window.setPosition(0,0)
	love.window.setTitle("bisection for sqrt(2)")
	love.graphics.setBackgroundColor(255,255,255)
	love.graphics.clear()
	love.graphics.setFont(love.graphics.newFont(40))
	love.keyboard.setKeyRepeat(true)
end

local N=0

function love.keypressed(key)
	if key == 'q' or key == 'escape' then
		love.event.quit()
	elseif key == 's' then
		love.graphics.newScreenshot():encode('png','output.png')
	elseif key == '[' then
		N=N-1
		if N<0 then N=0 end
	elseif key == ']' then
		N=N+1
	end
end

function love.draw()
	plot(0.9,2.1,-0.1,1.1,N)
end
